Attribute VB_Name = "Module1"
'Declareing Dealer related variables
'dealer can hit 1=yes 2=no
Public DealerCanHit, DealerHand(1 To 11), DCardsInHand, DAce(1 To 4), DPoints(1 To 11), DPointsTotal
'Declaring Deck related variables
'Cardsa refers to the deck
'Cardsb refers to the decks cards used with shuffling
'Cardsc hold the images for the deck
Public CardPicture, CardsDealt, CardsLeft, Cardsa(1 To 52), Cardsb(1 To 52), Cardsc(1 To 53)
'Declaring Player Hand related variables
Public Hand(1 To 11), PCardsInHand, PAce(1 To 4), PPoints(1 To 11), PMoney, PPointsTotal
'Declaring Temperary variables
Public Tp1, Tp2, Tp3, Tp4, Tp5, Tp6, Tp7, Tp8, Tp9
'Declaring Game Related Variables
'1 = the Dealer and 2 = the Player for Turn
'gip game in progress, hip hand in progress
'PBY player bet yet 1 = yes 2 = no
Public GIP, Turn, HIP, DSY, PBY, Bet

Public Sub ShuffleDeck(arg1)
Debug.Print "shuffle started"
' The arg1 variable is here for
' future support for multiple
' shuffling techniques

Debug.Print arg1
'this for loop resets the variable needed to check if a card has been shuffled into the deck
For i = 1 To 52
Cardsb(i) = 0
Next i

If arg1 = 1 Then
' When cards are shuffled the card numbers are assigned from left to right.
For j = 1 To 52
Tp1 = j - 1
Randomize
start1:
Tp2 = Int(Rnd * 52) + 1
If Cardsb(Tp2) = 0 Then
Cardsa(j) = Tp2
Cardsb(Tp2) = 1
Form1.Image3(Tp1).Visible = True
   
Else
GoTo start1:
End If
Debug.Print Cardsa(j)

Next j

Else
' this is temperary add more elseif stements for other shuffling
End If
End Sub

Public Sub NewGame()
GIP = 0
DSY = 1
HIP = 0
PBY = 2
Call ShuffleDeck(1)
For i = 0 To 10
Form1.Image1(i).Visible = False
Form1.Image2(i).Visible = False
Hand(i + 1) = ""
DealerHand(i + 1) = ""
Next i
CardsDealt = 0
DCardsInHand = 0
PCardsInHand = 0
PPointsTotal = 0
DPointsTotal = 0
End Sub

Public Sub ReShuffleDeck()
Debug.Print "reshuffle started"
For x = 0 To 51
Form1.Image3(x).Visible = False
Next x

'this for loop resets the variable needed to check if a card has been shuffled into the deck
For i = 1 To 52
Cardsb(i) = 0
Next i
'this for loop sets the variable needed to check if a card has been removed from the deck
If CardsDealt >= 1 Then
For i = 1 To PCardsInHand
Cardsb(Hand(i)) = 1
Next i
For k = 1 To DCardsInHand
Cardsb(Hand(k)) = 1

Next k
Else
End If
' When cards are shuffled the card numbers are assigned from left to right.
CardsLeft = 52 - CardsDealt
For j = 1 To CardsLeft
Tp1 = j - 1
Randomize
start1:
Tp2 = Int(Rnd * 52) + 1
If Cardsb(Tp2) = 0 Then
Cardsa(j) = Tp2
Cardsb(Tp2) = 1
Form1.Image3(Tp1).Visible = True
Else
GoTo start1:
End If
Debug.Print Cardsa(j)

Next j

End Sub

Public Sub deal()
If GIP = 0 Then
GIP = 1
HIP = 1
' deal the first card to the player and show it
CardsDealt = CardsDealt + 1
Call UpdateDeck
PCardsInHand = PCardsInHand + 1
Hand(PCardsInHand) = Cardsa(52 - CardsDealt)
Call UpdateHand(2)
Call DrawCard(1, PCardsInHand - 1, Hand(PCardsInHand))
'deal second card to the dealer and show back only
CardsDealt = CardsDealt + 1
Call UpdateDeck
DCardsInHand = DCardsInHand + 1
DealerHand(DCardsInHand) = Cardsa(52 - CardsDealt)
Call UpdateHand(1)
Call DrawCard(2, DCardsInHand - 1, 53)
'deal the third card to player and show it
CardsDealt = CardsDealt + 1
Call UpdateDeck
PCardsInHand = PCardsInHand + 1
Hand(PCardsInHand) = Cardsa(52 - CardsDealt)
Call UpdateHand(2)
Call DrawCard(1, PCardsInHand - 1, Hand(PCardsInHand))
'deal the fourth card to the dealer and show it
CardsDealt = CardsDealt + 1
Call UpdateDeck
DCardsInHand = DCardsInHand + 1
DealerHand(DCardsInHand) = Cardsa(52 - CardsDealt)
Call UpdateHand(1)
Call DrawCard(2, DCardsInHand - 1, DealerHand(DCardsInHand))
Turn = 2
Else
MsgBox ("Sorry a hand has been already been dealt!")
End If
End Sub

Public Sub hitme(arg1)
If agr1 = 1 Then
'dealer hits
If dealcanhit = 1 Then
CardsDealt = CardsDealt + 1
Call UpdateDeck
DCardsInHand = DCardsInHand + 1
DealerHand(DCardsInHand) = Cardsa(52 - CardsDealt)
Call UpdateHand(1)
Call DrawCard(2, DCardsInHand - 1, DealerHand(PCardsInHand))
Call AddUpHand(1)
Else
Form1.Label3.Caption = "Dealer Stays."
End If
Turn = 2
ElseIf arg1 = 2 Then
'player hits
CardsDealt = CardsDealt + 1
Call UpdateDeck
PCardsInHand = PCardsInHand + 1
Hand(PCardsInHand) = Cardsa(52 - CardsDealt)
Call UpdateHand(2)
Call DrawCard(1, PCardsInHand - 1, Hand(PCardsInHand))
Call AddUpHand(2)
Call DealerTurn
End If
End Sub

Public Sub DrawCard(arg1, arg2, arg3)
'arg1 represents whether the draw is for the dealer=2 or the player=1
'arg2 represents which card to draw image into
'arg3 represents which cardface to draw on the card
If arg1 = 1 Then
' this code block represents the players cards
Form1.Image2(arg2).Picture = LoadPicture(App.Path & "\images\" & arg3 & ".jpg")
Else
' this code block represents the dealers cards
Form1.Image1(arg2).Picture = LoadPicture(App.Path & "\images\" & arg3 & ".jpg")
End If
End Sub

Public Sub UpdateDeck()
If CardsDealt >= 1 Then
Form1.Image3(52 - CardsDealt).Visible = False
Else
If GIP = 0 Then
For i = 1 To 52
Form1.Image3(i).Visible = True
Next i
Else
End If
End If
End Sub
Public Sub UpdateHand(arg1)
If arg1 = 1 Then
Form1.Image1(DCardsInHand - 1).Visible = True
Else
Form1.Image2(PCardsInHand - 1).Visible = True
End If
End Sub

Public Sub AddUpHand(arg1)
'if arg1 = 1 represents the dealer
If arg1 = 1 Then

For i = 1 To DCardsInHand
Call GetPoints(DealerHand(i))
addit:
DPointsTotal = DPointsTotal + DPoints(i)
If DPointsTotal > 21 Then
'check for aces
If DPoints(i) = 11 Then
DPoints(i) = 1
GoTo addit:
Else
End If
Else

Call Bust(1)

End If
Next i

ElseIf arg1 = 2 Then
'player add up

For i = 1 To PCardsInHand
Call GetPoints(Hand(i))
addit2:
PPointsTotal = PPointsTotal + PPoints(i)
If PPointsTotal > 21 Then
'check for aces
If PPoints(i) = 11 Then
PPoints(i) = 1
GoTo addit2:
Else
End If

Else

Call Bust(1)

End If
Next i


End If
End Sub
Public Sub Bust(arg1)
If arg1 = 1 Then
'dealer busts
Call Winner(2)
ElseIf arg1 = 2 Then
'player busts
Call Winner(1)
End If

End Sub
Public Sub Winner(arg1)
If arg1 = 1 Then
'dealer wins
Form1.Label3.Caption = "The dealer has won! Your bet will be kept!"
ElseIf arg1 = 2 Then
'player wins
PMoney = PMoney + Bet
Form1.Label3.Caption = "You have won! Your pot will be added to your bank!"
Form1.Label5.Caption = "$" & PMoney
End If

End Sub
Public Sub stay(arg1)
If arg1 = 1 Then
'dealer stays
dstay = 1
DealerCanHit = 0
Turn = 2

ElseIf arg1 = 2 Then
'player stays
If dstay = 1 Then
Call AddUpHand(1)
Call AddUpHand(2)
If DPointsTotal > PPointsTotal Then
HIP = 0
Call Winner(1)
ElseIf PPointsTotal > DPointsTotal Then
HIP = 0
Call Winner(2)
End If
Else
Call DealerTurn
End If

Else
Call AddUpHand(1)
Call AddUpHand(2)
If DPointsTotal > PPointsTotal Then
HIP = 0
Call Winner(1)
ElseIf PPointsTotal > DPointsTotal Then
HIP = 0
Call Winner(2)
End If
End If
End Sub

Public Sub DealerTurn()
If DealerCanHit = 1 Then
Call AddUpHand(1)
If DPointsTotal <= 16 Then
Call hitme(1)
ElseIf DPointsTotal >= 17 Then
Call stay(1)
ElseIf DPointsTotal = 21 Then
Call Winner(1)
End If
Else
Call stay(3)
End If
End Sub

Public Sub GetPoints(arg1)
If arg1 = 1 Then Tp5 = 11
If arg1 = 2 Then Tp5 = 2
If arg1 = 3 Then Tp5 = 3
If arg1 = 4 Then Tp5 = 4
If arg1 = 5 Then Tp5 = 5
If arg1 = 6 Then Tp5 = 6
If arg1 = 7 Then Tp5 = 7
If arg1 = 8 Then Tp5 = 8
If arg1 = 9 Then Tp5 = 9
If arg1 = 10 Then Tp5 = 10
If arg1 = 11 Then Tp5 = 10
If arg1 = 12 Then Tp5 = 10
If arg1 = 13 Then Tp5 = 10
If arg1 = 14 Then Tp5 = 11
If arg1 = 15 Then Tp5 = 2
If arg1 = 16 Then Tp5 = 3
If arg1 = 17 Then Tp5 = 4
If arg1 = 18 Then Tp5 = 5
If arg1 = 19 Then Tp5 = 6
If arg1 = 20 Then Tp5 = 7
If arg1 = 21 Then Tp5 = 8
If arg1 = 22 Then Tp5 = 9
If arg1 = 23 Then Tp5 = 10
If arg1 = 24 Then Tp5 = 10
If arg1 = 25 Then Tp5 = 10
If arg1 = 26 Then Tp5 = 10
If arg1 = 27 Then Tp5 = 11
If arg1 = 28 Then Tp5 = 2
If arg1 = 29 Then Tp5 = 3
If arg1 = 30 Then Tp5 = 4
If arg1 = 31 Then Tp5 = 5
If arg1 = 32 Then Tp5 = 6
If arg1 = 33 Then Tp5 = 7
If arg1 = 34 Then Tp5 = 8
If arg1 = 35 Then Tp5 = 9
If arg1 = 36 Then Tp5 = 10
If arg1 = 37 Then Tp5 = 10
If arg1 = 38 Then Tp5 = 10
If arg1 = 39 Then Tp5 = 10
If arg1 = 40 Then Tp5 = 11
If arg1 = 41 Then Tp5 = 2
If arg1 = 42 Then Tp5 = 3
If arg1 = 43 Then Tp5 = 4
If arg1 = 44 Then Tp5 = 5
If arg1 = 45 Then Tp5 = 6
If arg1 = 46 Then Tp5 = 7
If arg1 = 47 Then Tp5 = 8
If arg1 = 48 Then Tp5 = 9
If arg1 = 49 Then Tp5 = 10
If arg1 = 50 Then Tp5 = 10
If arg1 = 51 Then Tp5 = 10
If arg1 = 52 Then Tp5 = 10
End Sub
